Package: flowCHIC
Encoding: UTF-8
Type: Package
Title: Analyze flow cytometric data using histogram information
Version: 1.45.0
Date: 2015-03-05
Author: Joachim Schumann <joachim.schumann@ufz.de>, Christin Koch <christin.koch@ufz.de>, Ingo Fetzer <info.fetzer@stockholmresilience.su.se>, Susann Müller <susann.mueller@ufz.de>
Maintainer: Author: Joachim Schumann <joachim.schumann@ufz.de>
Description: A package to analyze flow cytometric data of complex microbial communities based on histogram images
License: GPL-2
URL: http://www.ufz.de/index.php?en=16773
biocViews: ImmunoOncology, CellBasedAssays, Clustering, FlowCytometry,
        Software, Visualization
Depends: R (>= 3.1.0)
Imports: methods, flowCore, EBImage, vegan, hexbin, ggplot2, grid
Collate: AllGenerics.R fcs_to_img.R img_sub.R calculate_overlaps_xor.R
        plot_nmds.R
git_url: https://git.bioconductor.org/packages/flowCHIC
git_branch: devel
git_last_commit: c56715d
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 21:09:26 UTC; biocbuild

######
## Create histogram images
######

setMethod("fcs_to_img",signature=(files="character"),

definition = function(files,transformation=FALSE,ch1="FS.Log",ch2="FL.4.Log",
                      width=300,height=300,...){
  
  
  dir.create("chic_images")
  setwd("chic_images")
  
  for(f in files) {
    frame <- read.FCS(f,alter.names=TRUE,transformation=transformation,...) # read FCS file
    png(filename=sub(pattern="*.fcs",replacement=".png",basename(f)),width=width,height=height,
         units = "px",...)
    
    mat<-exprs(frame) # get the expression values 
    x<- mat[,ch1]
    y<- mat[,ch2]
    bin <- hexbin(x,y, xbin = 128) # perform hexbin
    df <- data.frame(hcell2xy(bin), count = bin@count)
    
    theme_map <- function (base_size = 12, base_family ="") {
                 theme_bw(base_size = base_size, base_family = base_family) %+replace% 
                 theme(legend.position = "none",
                       panel.background=element_blank(),
                       panel.border=element_blank(),
                       panel.margin=unit(0, "lines"),
                       plot.background=element_blank(),...)} # change theme attibutes
    
    print(ggplot(df, aes(x = x, y = y)) +  geom_point(aes(color = count)) + 
    scale_color_gradient(low = "white", high = "black" , na.value = "black", 
    limit = c(0, 200))+theme_map()+xlab(ch1)+ylab(ch2),...) # plot
   
  
    dev.off()
  } 
  setwd("..")
})

######
## Calculate overlap and XOR images
######

setMethod("calculate_overlaps_xor",signature=(subsets="character"),

definition = function (subsets,verbose=FALSE) {
  
  if(verbose){
  cat(paste("Label","Area",sep="\t"),file="Results_overlaps.txt",sep="\n") # create table
  cat(paste("Label","IntDen",sep="\t"),file="Results_xor.txt",sep="\n") # create table
  }
  
  newlist<-list() 
  
  inverse = function(x) (x-1)*(-1) # inverse an image
  
  bXOR = function(x, y) {         # perform XOR on two images
    x = round(x@.Data * (2^8-1),digits=3)
    y = round(y@.Data * (2^8-1),digits=3)
    x = x * (2^8-1)
    y = y * (2^8-1)
    xo = bitwXor(x, y)
    Image(xo / (2^8-1), dim = dim(x))
  }
  df_overlap = data.frame(Label=character(),Area=numeric())
  df_xor = data.frame(Label=character(),IntDen=numeric())
  
  for(i in 1:(length(subsets)-1)){
    c=i+1
    x <- readImage(subsets[i])
    xgray<-channel(x,"gray")
    neg1<-inverse(xgray)
    for(j in c:length(subsets)) {
      y <- readImage(subsets[j])
      ygray<-channel(y,"gray")
      neg2<-inverse(ygray)
      addim<-(neg1+neg2)
      addimgr<-channel(addim,"gray")
      bin<-addimgr<.004
      l<-length(bin[bin==FALSE]) # calculate overlap area
      
      overname<-paste("overlap_",sub("^([^.]*).*", "\\1",basename(subsets[i])),
                      "_&_",sub("^([^.]*).*", "\\1",basename(subsets[j])),".png",sep="")
      xo = bXOR(xgray, ygray) # perform XOR on two images
      lxor<-length(xo)
      m<-round(mean(xo)*255,digits=3)
      
      xorname<-paste("xor_",sub("^([^.]*).*", "\\1",basename(subsets[i])),
                     "_&_",sub("^([^.]*).*", "\\1",basename(subsets[j])) ,".png",sep="")
      
      if(verbose){
      cat(paste(overname,l,sep="\t"),file="Results_overlaps.txt",append=TRUE,sep="\n") # write values to file
      cat(paste(xorname,round(lxor*m,digits=0),sep="\t"),file="Results_xor.txt",
          append=TRUE,sep="\n") # write values to file
      }
      
      df_overlap = rbind(df_overlap,data.frame(Label=overname,Area=l))
      df_xor = rbind(df_xor,data.frame(Label=xorname,IntDen=round(lxor*m,digits=0)))	    
      
    }
  }
  newlist$overlap<-df_overlap
  newlist$xor<-df_xor
  return(newlist)
})

######
## Create NMDS plot
######

setMethod("plot_nmds",signature=c(x="data.frame",y="data.frame"),
definition = function(x,y, show_cluster=FALSE,type="p",main="",
                      col_nmds="black",cex=0.6,pos=1,group,legend_pos="topleft",abiotic,
                      p.max=0.05,col_abiotic="magenta",verbose=FALSE,...){

  newlist<-list()
  
  x$Label<-gsub("overlap_","",x$Label)  #removes "overlap_" from file labels
  x$Label<-gsub(".png","",x$Label)  #removes ".png" from file labels
  
  label.split<-strsplit(as.character(x$Label),"_&_")  #creates a file with proper label names
  
  
  nam<-NULL  #creates an empty vector file
  for (i in 1:length(label.split)) nam<-rbind(nam, cbind(label.split[[i]][1],
                                                         label.split[[i]][2]))  #creates a file ("nam") with all combinations of label names in it 
  
  dats<-data.frame(Label=x$Label, Label.1=nam[,1], Label.2=nam[,2],
                   IntDen=y$IntDen, Area=x$Area, IntDen.Area=y$IntDen/x$Area/100)  #final data file ("dats") is created by merging and conversion of XOR and overlay data
  
  size<-length(unique(dats$Label.1))+1  #number of unique data labels is estimated
  mat<-matrix(nrow=size, ncol=size)  #empty matrix ('mat') for disimilariy matrix is created
  j=1  #counter J created and set to 1
  for (i in unique(dats$Label.1)) {  #dissimilarity according to formula 1 in MS for each combination is calculated and stored in matrix 'mat'
    mat[,j]<-c(rep(NA,size-length(dats$IntDen.Area[dats$Label.1==i])),
               dats$IntDen.Area[dats$Label.1==i])
    j<-j+1
  }
  
  diag(mat)<-0  #diagonals are filled up with '0' values
  colnames(mat)<-rownames(mat)<-union(unique(dats$Label.1),
                                      unique(dats$Label.2))  #label names are written into matrix
  print(colnames(mat))
  mat.dist<-as.dist(mat)  #matrix mat is converted to dissimilarity matrix ('mat.dist') to be used with metaMDS
  
  if(show_cluster){  
    par(mfrow=c(1,2))
    plot(hclust(mat.dist, "average"), hang=-1)  #calculates and plots cluster analysis from the dissimilarity matrix using 'average' distances within cluster grouping
  }
  
  mds.out<-metaMDS(mat.dist, autotransform=FALSE)  #NMDS analysis is performed using dissimilarity matrix 'mat.dist'
  newlist$mds.out<-mds.out
  
  
  if(missing(group)){    
    plot(mds.out, type="n",display="sites",main=main)  ## plots result
    points(mds.out, type=type,col=col_nmds,...)  ## add points
    text(mds.out,cex=cex,pos=pos) 
    
  
  } else{
    color<-group[,1]
    plot(mds.out, type="n",display="sites",main=main)
    points(mds.out, col=color , pch=as.numeric(color))
    text(mds.out,cex=cex,pos=pos) 
    legend(x=legend_pos, legend=unique(color),  pch=as.numeric(unique(color)),
           col=as.numeric(unique(color)))
    ordihull(mds.out, groups=color, lty=2, col="darkgrey")
  }
  
  #######The following section gives a description if you want to include environmental data for MDS analysis###################

  if(!missing(abiotic)){
    ef<-envfit(mds.out, abiotic, permutation=999)  #calculates the relevant environmental parameters for the nMDS #result based on 999 Monte-Carlo permutations
    plot(ef,cex=cex,p.max=p.max, col=col_abiotic)  #plots the most relevant environmental parameters (with a p.max <=0.05) into the MDS
    newlist$ef<-ef
  }
  
  
  if(verbose){
    return(newlist)
  }
 
})

setGeneric("fcs_to_img", function(files, ...) standardGeneric("fcs_to_img"))
setGeneric("img_sub", function(files, ...) standardGeneric("img_sub"))
setGeneric("calculate_overlaps_xor", function(subsets, ...) standardGeneric("calculate_overlaps_xor"))
setGeneric("plot_nmds", function(x, y, ...) standardGeneric("plot_nmds"))

### R code from vignette source 'flowCHICmanual.Rnw'

###################################################
### code chunk number 1: loadPackage
###################################################
# Load package
library(flowCHIC)


###################################################
### code chunk number 2: GetChannels (eval = FALSE)
###################################################
## # Set the working directory to the path where your FCS files are located
## # Type the path into the quotes
## setwd("") 
## # Or in Windows use
## setwd(choose.dir(getwd(), "Choose the folder containing the FCS files"))
## # Get a list of the filenames of the FCS files located in your working directory
## files <- list.files(getwd(),full=TRUE,pattern="*.fcs")
## # Get a list of the filenames of the FCS files included to the package
## files <- list.files(system.file("extdata",package="flowCHIC"),
## full=TRUE,pattern="*.fcs")
## # Read the first FCS file as flowFrame
## frame <- read.FCS(files[1],alter.names=TRUE,transformation=FALSE) 
## # Get a list of the parameter/channel names
## unname(frame@parameters@data$name)


###################################################
### code chunk number 3: CreateImage (eval = FALSE)
###################################################
## # Create the histogram images using default parameters
## fcs_to_img(files)
## # Create the histogram images using different channels
## # Not working for the FCS files attached to the package
## fcs_to_img(files,ch1="SS.Log",ch2="FL.1.Log")


###################################################
### code chunk number 4: CreateSubset (eval = FALSE)
###################################################
## # Create the histogram image subsets using default parameters
## img_sub(files,ch1="FS.Log",ch2="FL.4.Log")


###################################################
### code chunk number 5: CreateChangedSubset (eval = FALSE)
###################################################
## # Create the histogram images using different boundaries for the x/y axis
## # and a different value for the maximal value set to black
## # These values work well for the first downloadable dataset and 
## # the FCS files included to the package
## img_sub(files,x_start=200,x_end=3500,y_start=1000,y_end=3000,maxv=160)


###################################################
### code chunk number 6: CalculateXorOver (eval = FALSE)
###################################################
## # Save the names of all subset images as a list
## subsets <- list.files(path=paste(getwd(),"chic_subset",sep="/"),full=TRUE,pattern="*.png")
## # Calculate overlap and XOR images and write values to two new files
## results<-calculate_overlaps_xor(subsets)


###################################################
### code chunk number 7: CalculateXorOver_files (eval = FALSE)
###################################################
## # Save the names of all subset images as a list
## subsets <- list.files(path=paste(getwd(),"chic_subset",sep="/"),full=TRUE,pattern="*.png")
## # Calculate overlap and XOR images and write values to two new files
## calculate_overlaps_xor(subsets,verbose=TRUE)


###################################################
### code chunk number 8: NMDSXorOverlapList (eval = FALSE)
###################################################
## # Show a NMDS plot of the samples
## plot_nmds(results$overlap,results$xor) 


###################################################
### code chunk number 9: readOverXor (eval = FALSE)
###################################################
## # Type the filename of the overlap data (including extension) into the quotes
## Results_overlaps<-read.table("Results_overlaps.txt",header=TRUE,sep="\t")  
## # Type the filename of the XOR data (including extension) into the quotes
## Results_xor<-read.table("Results_xor.txt",header=TRUE,sep="\t")  


###################################################
### code chunk number 10: NMDSXorOverlapRead (eval = FALSE)
###################################################
## # Show a NMDS plot of the samples
## plot_nmds(Results_overlaps,Results_xor) 


###################################################
### code chunk number 11: plotDefault
###################################################
# Load datasets
data(Results_overlaps)
data(Results_xor)
# Show a NMDS plot of the samples
plot_nmds(Results_overlaps,Results_xor) 


###################################################
### code chunk number 12: plotDefaultChanged
###################################################
# Change default parameters
plot_nmds(Results_overlaps,Results_xor,main="NMDS plot",pos=3,pch=2,col_nmds="red")


###################################################
### code chunk number 13: overlapsmix
###################################################
# Load dataset
data(Results_overlaps_mix) 
# Show data (first five lines)
Results_overlaps_mix[1:5,]


###################################################
### code chunk number 14: xormix
###################################################
# Load dataset
data(Results_xor_mix)
# Show data (first five lines)
Results_xor_mix[1:5,]


###################################################
### code chunk number 15: plotDefault_mix
###################################################
# Plot
plot_nmds(Results_overlaps_mix,Results_xor_mix)


###################################################
### code chunk number 16: overlapsincol
###################################################
# Load dataset
data(Results_overlaps_incol) 
# Show data (first five lines)
Results_overlaps_incol[1:5,]


###################################################
### code chunk number 17: xorincol
###################################################
# Load dataset
data(Results_xor_incol)
# Show data (first five lines)
Results_xor_incol[1:5,]


###################################################
### code chunk number 18: plotDefault_incol
###################################################
# Plot
plot_nmds(Results_overlaps_incol,Results_xor_incol)


###################################################
### code chunk number 19: Groups
###################################################
# Create data frame with group assignments
groups<-data.frame("groups"=c(15,19,19,19,15,22,19,15,22,15,15,22,22,22,22,19,19))


###################################################
### code chunk number 20: plotGroup_incol
###################################################
# Plot
plot_nmds(Results_overlaps_incol,Results_xor_incol,group=groups)


###################################################
### code chunk number 21: abioticincol
###################################################
# Load dataset
data(abiotic_incol)
# Show data (first five lines)
abiotic_incol[1:5,]


###################################################
### code chunk number 22: plotAbiotic_incol
###################################################
# Plot
plot_nmds(Results_overlaps_incol,Results_xor_incol,
          abiotic=abiotic_incol[,-1])


###################################################
### code chunk number 23: plotAbioticGroup_incol
###################################################
# Plot
plot_nmds(Results_overlaps_incol,Results_xor_incol,group=groups,abiotic=abiotic_incol[,-1])


###################################################
### code chunk number 24: plotAbioticGroup_incolchanged
###################################################
# Plot
plot_nmds(Results_overlaps_incol,Results_xor_incol,group=groups,
          legend_pos="topright",abiotic=abiotic_incol[,-1],
          p.max=0.01,col_abiotic="darkred")


###################################################
### code chunk number 25: plotAbioticGroup_incolchanged_cluster
###################################################
# Plot
plot_nmds(Results_overlaps_incol,Results_xor_incol,show_cluster=TRUE,group=groups,
          legend_pos="topright",abiotic=abiotic_incol[,-1],
          p.max=0.01,col_abiotic="darkred")


###################################################
### code chunk number 26: plotAbioticGroup_incolchanged_verbose (eval = FALSE)
###################################################
## # Plot and print results
## plot_nmds(Results_overlaps_incol,Results_xor_incol,show_cluster=TRUE,group=groups,
##           legend_pos="topright",abiotic=abiotic_incol[,-1],
##           p.max=0.01,col_abiotic="darkred",verbose=TRUE)

######
## Create subsets of the histogram images
######

setMethod("img_sub",signature=(files="character"),
definition = function(files,transformation=FALSE,ch1="FS.Log",ch2="FL.4.Log",x_start=0,
                      x_end=4095,y_start=0,y_end=4095,xbin=128,maxv=200,width=300,
                      height=300,...){

dir.create("chic_subset") # create new folder
setwd("chic_subset") 

for(f in files) {

frame<-read.FCS(f,alter.names=TRUE,transformation=transformation,...) # read FCS file
png(filename=sub(pattern="*.fcs",replacement=".png",basename(f)),width=width,height=height,
    units = "px",...)
coords <- list(c(x_start,x_end), c(y_start,y_end)) # define subset area
names(coords) <- c(ch1, ch2)

Noise <- rectangleGate(filterId="Noise",  .gate = coords) # filter noise
Noise.subset <- Subset(frame, Noise) # create subset

mat<-exprs(Noise.subset) # get expressions
x<- mat[,ch1]
y<- mat[,ch2]
bin <- hexbin(x,y, xbin = xbin) # perform hexbin

df <- data.frame(hcell2xy(bin), count = bin@count)
theme_map <- function (base_size = 12, base_family ="") {
  theme_bw(base_size = base_size, base_family = base_family) %+replace% 
    theme(axis.line=element_blank(),axis.text.x=element_blank(),axis.text.y=element_blank(),
          axis.ticks=element_blank(),axis.title.x=element_blank(),
          axis.title.y=element_blank(),legend.position = "none",
          panel.background=element_blank(),panel.border=element_blank(),
          panel.grid.major=element_blank(),panel.grid.minor=element_blank(),
          panel.margin=unit(0, "lines"),plot.background=element_blank(),...)} # change theme

print(ggplot(df, aes(x = x, y = y)) +  geom_point(aes(color = count)) +
        scale_color_gradient(low = "white", high = "black" , na.value = "black",
        limit = c(0, maxv))+theme_map(),...) # save subset images

dev.off()
  }
setwd("..")
})

\name{calculate_overlaps_xor}
\encoding{UTF-8}
\alias{calculate_overlaps_xor}
\alias{calculate_overlaps_xor,character-method}
\docType{methods}
\title{Calculate overlap and XOR images}
\description{Calculate overlap and XOR images for each combination of every subset histogram   image.}
\usage{\S4method{calculate_overlaps_xor}{character}(subsets,verbose=FALSE)}
\arguments{
\item{subsets}{List of the subset image files. All files have to be in one folder. See the manual for more information about creating the list.}
\item{verbose}{logical (default=FALSE). Change to TRUE to print the calculated values to two new files called "Results_overlaps.txt" and "Results_xor.txt" to the working directory.}
}
\details{After saving a list containing the filenames of the subset histogram images this method calculates the XOR and overlap images/values for each combination of every image, returns the values and is able to write the values to two new files called "Results_overlaps.txt" and "Results_xor.txt" (see example section). See reference Koch et al. 2013 for more information about the calculation.}

\value{The \emph{calculate_overlaps_xor()} method calculates the overlap and XOR images and returns a list with two data frames containing the calculated data.}

\references{\emph{Christin Koch, Ingo Fetzer, Hauke Harms, and Susann Müller. CHIC - An Automated
Approach for the Detection of Dynamic Variations in Complex Microbial Communities.
Cytometry Part A, 2013.}}

\author{Joachim Schumann \email{joachim.schumann@ufz.de}, Christin Koch \email{christin.koch@ufz.de}, Ingo Fetzer \email{info.fetzer@stockholmresilience.su.se}, Susann Müller \email{susann.mueller@ufz.de}}

\examples{
require(EBImage)

## Calculate the overlap and XOR images
## Save the returned values as a list

# Get a list of the filenames of the FCS files
files <- list.files(system.file("extdata",package="flowCHIC"),
full=TRUE,pattern="*.fcs")
# Create histogram images and save them
fcs_to_img(files)
# Create subsets
img_sub(files,x_start=200,x_end=3500,y_start=1000,y_end=3000,maxv=160)
# Get a list of the filenames of the PNG files
subsets <- list.files(path=paste(getwd(),"chic_subset",sep="/"),full=TRUE,pattern="*.png")
# Calculate and save values as a list
results<-calculate_overlaps_xor(subsets)

## Calculate the overlap and XOR images
## Two new files called "Results_overlaps.txt" and
## "Results_xor.txt" are written to the working directory

# Get a list of the filenames of the FCS files
files <- list.files(system.file("extdata",package="flowCHIC"),
full=TRUE,pattern="*.fcs")
# Create histogram images and save them
fcs_to_img(files)
# Create subsets
img_sub(files,x_start=200,x_end=3500,y_start=1000,y_end=3000,maxv=160)
# Get a list of the filenames of the PNG files
subsets <- list.files(path=paste(getwd(),"chic_subset",sep="/"),full=TRUE,pattern="*.png")
# Calculate
calculate_overlaps_xor(subsets,verbose=TRUE)
}

\keyword{overlaps,xor}
\keyword{file.show(file.path(R.home("doc"),"KEYWORDS"))}

\name{Results_xor}
\docType{data}
\alias{Results_xor}
\title{Dataset with labels and intensity values of the FCS files included to the package}
\description{Example dataset containing labels and intensity values of each image pair of the FCS files included to the package.}
\usage{data(Results_xor)}
\format{Data frame with 3 observations of 2 variables.}
\value{Results of the method \emph{calculate_overlaps_xor()} on the FCS files included to the package.}
\keyword{datasets}

\name{Results_xor_mix}
\docType{data}
\alias{Results_xor_mix}
\title{Dataset with labels and intensity values of the first downloadable dataset}
\description{Example dataset containing labels and intensity values of each image pair of the first downloadable dataset (see manual).}
\usage{data(Results_xor_mix)}
\format{Data frame with 4005 observations of 2 variables.}
\value{Results of the method \emph{calculate_overlaps_xor()} on the subsets of the first downloadable dataset.}
\keyword{datasets}

\name{flowCHIC-package}
\encoding{UTF-8}
\alias{flowCHIC}
\docType{package}
\title{
Analyze flow cytometric data using histogram information
}
\description{
A package to analyze flow cytometric data of complex microbial communities based on histogram images.
}
\details{
\tabular{ll}{
Package: \tab flowCHIC\cr
Type: \tab Package\cr
Version: \tab 1.0.1\cr
Date: \tab 2014-11-26\cr
License: \tab GPL-2\cr
}
abiotic_incol
fcs_to_img
flowCHIC
img_sub
calculate_overlaps_xor
plot_nmds
Results_xor_mix
Results_xor_incol
Results_overlaps_mix
Results_overlaps_incol
}
\author{Joachim Schumann \email{joachim.schumann@ufz.de}, Christin Koch \email{christin.koch@ufz.de}, Ingo Fetzer \email{info.fetzer@stockholmresilience.su.se}, Susann Müller \email{susann.mueller@ufz.de}
}
\references{\emph{Christin Koch, Ingo Fetzer, Hauke Harms, and Susann Müller. CHIC - An Automated
Approach for the Detection of Dynamic Variations in Complex Microbial Communities.
Cytometry Part A, 2013.}}

\seealso{\code{\link[flowCore:flowCore-package]{flowCore}},\code{\link[flowViz:flowViz-package]{flowViz}},\code{\link[flowCyBar:flowCyBar-package]{flowCyBar}}}

\keyword{package}

\name{Results_xor_incol}
\docType{data}
\alias{Results_xor_incol}
\title{Dataset with labels and intensity values of the second downloadable dataset}
\description{Example dataset containing labels and intensity values of each image pair of the second downloadable dataset (see manual).}
\usage{data(Results_xor_incol)}
\format{Data frame with 136 observations of 2 variables.}
\value{Results of the method \emph{calculate_overlaps_xor()} on the subsets of the second downloadable dataset.}
\keyword{datasets}

\name{fcs_to_img}
\encoding{UTF-8}
\alias{fcs_to_img}
\alias{fcs_to_img,character-method}
\docType{methods}
\title{FCS files to images}
\description{Create histogram images of FCS files.}
\usage{\S4method{fcs_to_img}{character}(files,transformation=FALSE,ch1="FS.Log",ch2="FL.4.Log",width=300,height=300,\dots)}
\arguments{
\item{files}{List of all .fcs files. All files have to be in one folder. See the manual for more information about creating the list.}
\item{transformation}{Character string to define the type of data transformation (default=\emph{FALSE}). Fore more details type "?read.FCS" into R command line.}
\item{ch1}{Character string indicating the first channel of the histogram (x-axis) (default=\emph{"FS.Log"}). See the manual for more details.}
\item{ch2}{Character string indicating the second channel of the histogram (y-axis) (default=\emph{"FL.4.Log"}). See the manual for more details.}
\item{width}{Width (pixel) of the resulting histogram image (default=\emph{300}).}
\item{height}{Height (pixel) of the resulting histogram image (default=\emph{300}).}
\item{...}{Additional parameters used for reading the FCS files, for creating the PNG images and for creating the plots. Fore more details type "?read.FCS", "?png" or "??ggplot2" into R command line.}
}
\details{This method creates histogram images of FCS files using the \emph{ggplot} method of the package "ggplot2" (see reference Wickham 2009). After creating a list containing the names of the FCS files a new folder called "chic_images" is created in the working directory  that contains the histogram images. Choose the two channels that are used for plotting on the x/y-axis.}

\value{The \emph{fcs_to_img()} method creates histogram images of FCS files.}

\references{\emph{H. Wickham. ggplot2: elegant graphics for data analysis. Springer New York,2009.}}

\author{Joachim Schumann \email{joachim.schumann@ufz.de}, Christin Koch \email{christin.koch@ufz.de}, Ingo Fetzer \email{info.fetzer@stockholmresilience.su.se}, Susann Müller \email{susann.mueller@ufz.de}}

\examples{
require(flowCore)
require(ggplot2)

## Write the histogram images of the FCS files that are included 
## to the package in a new subfolder of the working directory
## called "chic_images"

# Get a list of the filenames of the FCS files
files <- list.files(system.file("extdata",package="flowCHIC"),
full=TRUE,pattern="*.fcs")
# Create histogram images and save them
fcs_to_img(files)
}


\keyword{fcs}
\keyword{file.show(file.path(R.home("doc"),"KEYWORDS"))}

\name{abiotic_incol}
\docType{data}
\alias{abiotic_incol}
\title{Dataset with abiotic data}
\description{Example dataset containing abiotic parameters used for the NMDS plot of the second downloadable dataset (see manual).}
\usage{data(abiotic_incol)}
\format{Data frame with 17 observations of 6 variables.}
\value{Abiotic data of the second downloadable dataset.}
\keyword{datasets}

\name{plot_nmds}
\encoding{UTF-8}
\alias{plot_nmds}
\alias{plot_nmds,data.frame,data.frame-method}
\docType{methods}
\title{NMDS plot of samples}
\description{NMDS plot of samples based on the calculated XOR and overlap values}   
\usage{\S4method{plot_nmds}{data.frame,data.frame}(x,y,show_cluster=FALSE,type="p",main="",col_nmds="black",cex=0.6,pos=1,
group,legend_pos="topleft",abiotic,p.max=0.05,col_abiotic="magenta",verbose=FALSE,\dots)}
\arguments{
\item{x}{Table with calculated overlap data.}
\item{y}{Table with calculated XOR data.}
\item{show_cluster}{logical (default=\emph{FALSE}). Change to TRUE if cluster dendrogram shall be plotted.}
\item{type}{Type of the plot (default=\emph{"p"}). The \emph{"p"} indicates points without connecting lines within the plot. 
Only used if \bold{group}=FALSE. For more details type "?points" into R command line.}
\item{main}{Character string used as title of the NMDS plot (default="").}
\item{col_nmds}{Color used for the plotted data points if \bold{group}=FALSE (default=\emph{"black"}).}
\item{cex}{numeric (default=0.6). Character expansion factor. Used for the final size of the characters.}
\item{pos}{Position of the text (default=2). Values of 1, 2, 3 and 4, respectively indicate positions below, 
to the left of, above and to the right of the specified coordinates.}
\item{group}{Data frame containing group assignments. The order and the number of these groups has to be identical to the order and the number of the samples printed in R. Use only integer values in the range from 1 to 25. See the manual for more details.}
\item{legend_pos}{Position of the legend (default=\emph{"topleft"}) if \bold{group}=TRUE. 
For more details type "?legend" into R command line.}
\item{abiotic}{Table with abiotic data. Should be a tab-delimited text file using '.' as decimal delimiter. 
Use one row for one sample and one column for one abiotic or experimental parameter. Use the first column for the first parameter 
and the first line as header. The order and the number of the lines has to be identical to the order and the number of the 
samples printed in R.}
\item{p.max}{Decimal number defining the significance level of the abiotic parameters (default=0.05) if \bold{abiotic}=TRUE. Only parameters less/equal this value are plotted.}
\item{col_abiotic}{Color used for the plotted abiotic parameters (default=\emph{"magenta"}).}
\item{verbose}{logical (default=FALSE). Do not print additional information. Change to TRUE to print results of the 
metaMDS method and the p-values of the abiotic parameters.}
\item{...}{Additional parameters used for plotting the data points if \bold{group}=FALSE. 
For more details type "?points" into R command line.}
}
\details{
This method is used for calculating the similarities found in the histogram images of cytometric data. A dissimilarity matrix is generated from the pairwise comparison of histogram images based on the values returned by the method \emph{calculate_overlaps_xor} or saved in the files "Results_overlaps.txt" and "Results_xor.txt". See reference Koch et al. 2013 for more details. Ensuing from this matrix nonmetric multidimensional scaling (NMDS) is performed to show the results. The NMDS plot is calculated using the \emph{metaMDS} method of the package "vegan" (see reference Warnes et al. 2013). In addition, a cluster analysis can be performed to reveal samples with high similarities.
}

\value{The \emph{plot_nmds()} method calculates a NMDS plot of the samples and an additional cluster dendrogram.}

\references{\emph{Christin Koch, Ingo Fetzer, Hauke Harms, and Susann Müller. CHIC - An Automated
Approach for the Detection of Dynamic Variations in Complex Microbial Communities.
Cytometry Part A, 2013.}

\emph{Jari Oksanen, F. Guillaume Blanchet, Roeland Kindt, Pierre Legendre, Peter R. Minchin, R. B.
  O'Hara, Gavin L. Simpson, Peter Solymos, M. Henry H. Stevens and Helene Wagner (2013). vegan:
  Community Ecology Package. R package version 2.0-10. http://CRAN.R-project.org/package=vegan}}

\author{Joachim Schumann \email{joachim.schumann@ufz.de}, Christin Koch \email{christin.koch@ufz.de}, Ingo Fetzer \email{ingo.fetzer@stockholmresilience.su.se}, 
Susann Müller \email{susann.mueller@ufz.de}}
\examples{
require(vegan)

## Show the NMDS plot of the sample files
## included to the package

# Get a list of the filenames of the FCS files
files <- list.files(system.file("extdata",package="flowCHIC"),
full=TRUE,pattern="*.fcs")
# Create histogram images
fcs_to_img(files)
# Create subsets
img_sub(files,x_start=200,x_end=3500,y_start=1000,y_end=3000,maxv=160)
# Get a list of the filenames of the subset PNG files
subsets <- list.files(path=paste(getwd(),"chic_subset",sep="/"),full=TRUE,pattern="*.png")
# Calculate
results<-calculate_overlaps_xor(subsets)
# Show NMDS plot ensuing from the returned values
plot_nmds(x=results$overlap,y=results$xor)


## Show the NMDS plot of the dataset "mix""

data(Results_overlaps_mix)
data(Results_xor_mix)
plot_nmds(Results_overlaps_mix,Results_xor_mix)

## Show the NMDS plot of the dataset "incol""

data(Results_overlaps_incol)
data(Results_xor_incol)
plot_nmds(Results_overlaps_incol,Results_xor_incol)

## Show the NMDS plot of the dataset "incol"" with group assignment
## and abiotic data
## Print results of the metaMDS method and the p-values of the abiotic parameters
## Show a cluster dendrogram

data(Results_overlaps_incol)
data(Results_xor_incol)
groups<-data.frame("groups"=c(15,19,19,19,15,22,19,15,22,15,15,22,22,22,22,19,19))
data(abiotic_incol)
plot_nmds(Results_overlaps_incol,Results_xor_incol,show_cluster=TRUE,group=groups,abiotic=abiotic_incol[,-1],verbose=TRUE)

}

\keyword{nmds}
\keyword{file.show(file.path(R.home("doc"),"KEYWORDS"))}

\name{img_sub}
\encoding{UTF-8}
\alias{img_sub}
\alias{img_sub,character-method}
\docType{methods}
\title{Create image subsets}
\description{Create subsets of FCS files and the resulting histogram images.}
\usage{\S4method{img_sub}{character}(files,transformation=FALSE,ch1="FS.Log",ch2="FL.4.Log",x_start=0,x_end=4095,y_start=0,y_end=4095,xbin=128,maxv=200,width=300,height=300,\dots)}
\arguments{
\item{files}{Character list of .fcs files. All files have to be in one folder. See the manual for more information about creating the list.}
\item{transformation}{Character string to define the type of data transformation (default=\emph{FALSE}). Fore more details type "?read.FCS" into R command line.}
\item{ch1}{Character string indicating the first channel of the histogram (x-axis) (default=\emph{"FS.Log"}). See the manual for more details.}
\item{ch2}{Character string indicating the second channel of the histogram (y-axis) (default=\emph{"FL.4.Log"}). See the manual for more details.}
\item{x_start}{Start of the rectangle gate on the x-axis (default=\emph{0}). See the manual for more details.}
\item{x_end}{End of the rectangle gate on the x-axis (default=\emph{4095}). See the manual for more details.}
\item{y_start}{Start of the rectangle gate on the y-axis (default=\emph{0}). See the manual for more details.}
\item{y_end}{End of the rectangle gate on the y-axis (default=\emph{4095}). See the manual for more details.}
\item{xbin}{Number of bins within the histogram (default=\emph{128}).}
\item{maxv}{Maximal value of the expressions within the histogram that is set to the highest color value (black) (default=\emph{200}). See the manual for more details.}
\item{width}{Width (pixel) of the resulting histogram image (default=\emph{300}).}
\item{height}{Height(pixel) of the resulting histogram image (default=\emph{300}).}
\item{...}{Additional parameters used for reading the FCS files, creating the PNG images and for plotting. For more details type "?read.FCS", "?png" or "??ggplot2" into R command line.}
}
\details{This method creates subsets of FCS files and the resulting histogram images using the \emph{ggplot} method of the package "ggplot2" (see reference Wickham 2009). After creating a list containing the names of the FCS files a new folder called "chic_subset" is created in the working directory  that contains the subset histogram images. Choose the two channels that are used for plotting on the x/y-axis. Define the start and the end of the rectangle gate of both axes. See the manual for more details.}

\value{The \emph{img_sub()} method creates subsets of the histogram images.}

\references{\emph{H. Wickham. ggplot2: elegant graphics for data analysis. Springer New York,2009.}}

\author{Joachim Schumann \email{joachim.schumann@ufz.de}, Christin Koch \email{christin.koch@ufz.de}, Ingo Fetzer \email{info.fetzer@stockholmresilience.su.se}, Susann Müller \email{susann.mueller@ufz.de}}

\examples{
require(flowCore)
require(ggplot2)

## Write the subset histogram images of the FCS files that are included 
## to the package in a new subfolder of the working directory
## called "chic_subset"

# Get a list of the filenames of the FCS files
files <- list.files(system.file("extdata",package="flowCHIC"),
full=TRUE,pattern="*.fcs")
# Create subsets
img_sub(files,x_start=200,x_end=3500,y_start=1000,y_end=3000,maxv=160)
}

\keyword{subset,fcs}
\keyword{file.show(file.path(R.home("doc"),"KEYWORDS"))}
